package com.fp.persistence.pgeneral.excel;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEFILETYPE*/
@Entity(name="TgeneFileType")
@Table(name="TGENEFILETYPE")
public class TgeneFileType extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneFileType
*/
@Id
@Column(name="FILECODE" ,nullable=false, updatable=false)
private String pk;
@Column(name="DESCRIPTION", nullable=true)

/**
* Descripción del tipo de dato
*/
private String description;

@Column(name="MANAGED", nullable=true)

/**
* Manejado por internamente
*/
private String managed;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistick locking del registro
*/
private Integer recordversion;

/**Contructor por defecto*/
public TgeneFileType(){
}
/**Contructor de TgeneFileType
@param pPk Clave Primaria del entity
*/
public TgeneFileType(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneFileType
*/
public static TgeneFileType find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneFileType obj = pEntityManager.find(TgeneFileType.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneFileType
@return El objeto que referencia a la Clave primaria de TgeneFileType
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneFileType
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneFileType
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de managed
@return valor de managed*/
public String getManaged(){
  return managed;
}
/**Fija el valor de managed
@param pManaged nuevo Valor de managed*/
public void setManaged(String pManaged){
  managed=pManaged;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneFileType))return false;
    TgeneFileType that = (TgeneFileType) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TgeneFileType
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TgeneFileType
*/
public Object createInstance(){
 TgeneFileType instance=new TgeneFileType();	
 return instance;
}
/**Clona la entidad TgeneFileType
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneFileType p=(TgeneFileType)this.clone();
  return p;
}
}
